/*
* ListaDetailCtrl
********************************************/
function ListaDetailCtrl($scope, $routeParams, persistencejs) {
    comprapp.tools.alturaMain(); 

    var listaRecetas = document.getElementById('listaRecetas');  
    angular.element(listaRecetas).css('height',(window.innerHeight-150) + 'px');

    $scope.refresh = function(){ $scope.$apply(); }
    $scope.recetasSeleccionadas=[];
    $scope.idsRecetasSeleccionadas=[];

    // list recetas seleccionadas
    $scope.listaId = $routeParams.listaId;
    var pieza = $scope.pieza = {};
    persistencejs.getLista($scope, $routeParams.listaId, function(){ 
        pieza = $scope.pieza; 
        $scope.editLista = $scope.pieza.name;
        $scope.recetasSeleccionadas = JSON.parse($scope.pieza.recetasJson);
        fillIdsRecetasSeleccionadas($scope.recetasSeleccionadas);
        ingredientesRecetasSeleccionadas($scope.recetasSeleccionadas);
        $scope.refresh();   
    });
   

    // lista de ingredientes en las recetas seleccionadas        
    var ingredientesRecetasSeleccionadas = function(obj) {
        $scope.pieza = {};
        $scope.ingredientes = [];
        $scope.idsIngredientes=[];
        angular.forEach(obj, function(o) {
            
            persistencejs.getReceta($scope, o.id, function(){ 
                pieza = $scope.pieza; 
                angular.forEach(JSON.parse($scope.pieza.ingredientesJson), function(or) {
                    if($scope.idsIngredientes[or.id+or.tipo]) {                      
                        $scope.idsIngredientes[or.id+or.tipo].cantidad = parseInt($scope.idsIngredientes[or.id+or.tipo].cantidad, 10) + parseInt(or.cantidad, 10);
                    } else {
                        $scope.idsIngredientes[or.id+or.tipo]=or;
                    }    
                });
                $scope.verIngredientes();
                $scope.refresh();   
            });
        });  
    }

    $scope.verIngredientes = function() {
        $scope.ingredientes = [];
        for (var i in $scope.idsIngredientes) {                  
            $scope.ingredientes.push($scope.idsIngredientes[i]); 
        }
    }


    //fill array idsRecetasSeleccionadas
    var fillIdsRecetasSeleccionadas = function(obj) {
        angular.forEach(obj, function(o) {
            $scope.idsRecetasSeleccionadas.push(o.id);
        });
    }

    //edit lista
    $scope.editList = function() {
        persistencejs.editLista($routeParams.listaId, $scope.editLista, $scope.recetasSeleccionadas);
    };

    //list all recetas
    var recetas = $scope.listaRecetas = [];
    persistencejs.fetchAllReceta($scope, function(){ 
        recetas = $scope.recetas; 

        // list recetas seleccionadas
        angular.forEach(recetas, function(receta) {            
            if($scope.idsRecetasSeleccionadas.indexOf(receta.id) !== -1) {
                receta.done=1;
            } else {
                receta.done=0;
            }
        });
        $scope.refresh(); 
    });  

    //seleccionar receta
    $scope.select = function(name, id, e){
        var elem = angular.element(e.srcElement);
        if (elem.hasClass('seleccionado')) {
          elem.removeClass('seleccionado');

          var index = $scope.recetasSeleccionadas.indexOf(id);
          $scope.recetasSeleccionadas.splice(index,1);
          ingredientesRecetasSeleccionadas($scope.recetasSeleccionadas);
        } else {
          elem.addClass('seleccionado');
          $scope.recetasSeleccionadas.push({'id':id, 'name':name});
          ingredientesRecetasSeleccionadas($scope.recetasSeleccionadas);
        }        
    }

    //seleccionar ingrediente
    $scope.selectIngrediente = function(e){
        var elem = angular.element(e.srcElement);
        if (elem.hasClass('seleccionado')) {
          elem.removeClass('seleccionado');
        } else {
          elem.addClass('seleccionado');
        }        
    }

}