/*
* RecetaDetailCtrl
********************************************/
function RecetaDetailCtrl($scope, $routeParams, persistencejs) {
	comprapp.tools.alturaMain();
	$scope.refresh = function() {$scope.$apply();}	
	
    var listaIngredientes = document.getElementById('listaIngredientes');  
    //angular.element(listaIngredientes).css('height',(window.innerHeight-150) + 'px');	 

	$scope.recetaId = $routeParams.recetaId;
	$scope.ingredientesSeleccionados=[];
	$scope.idsIngredientesSeleccionados=[];
    $scope.ingrediente = {};
	$scope.pieza = {}; 	
    
    //Edit or new recipe
    if ($scope.recetaId!=0) {
    	persistencejs.getReceta($scope, $scope.recetaId, function(){ 
    		$scope.name = $scope.pieza.name;
    		$scope.description = $scope.pieza.description;
    		$scope.ingredientesSeleccionados = JSON.parse($scope.pieza.ingredientesJson);
    		fillIdsIngredientesSeleccionados($scope.ingredientesSeleccionados);
    		$scope.refresh();   
    	});

        $scope.editReceta = function() {  
          persistencejs.editReceta(
            $scope.recetaId,
            $scope.name, 
            $scope.description,
            $scope.ingredientesSeleccionados
          );
          location.href='#/recetas';
        }
    } else {
        //add receta
        $scope.editReceta = function() {
            if ( !$scope.name.length ) { return; }   
            persistencejs.addReceta(
                $scope.name, 
                $scope.description,
                $scope.ingredientesSeleccionados
            );
            location.href='#/recetas';
        };        
    }

    //borrar ingrediente
    $scope.removeIngrediente = function(ing) {  
        var index = $scope.idsIngredientesSeleccionados.indexOf(ing.id);        
        $scope.idsIngredientesSeleccionados.splice(index,1);
        repintarIngredientes();
        listAllIngredientes();
    };	

    var repintarIngredientes = function() {
        angular.forEach($scope.ingredientesSeleccionados, function(ingrediente) {     
            if($scope.idsIngredientesSeleccionados.indexOf(ingrediente.id) === -1) {            	 
                var index = $scope.ingredientesSeleccionados.indexOf(ingrediente);	
                $scope.ingredientesSeleccionados.splice(index,1);
            } 
        });    	
    }

    //seleccionar ingrediente de pop lista de ingredientes
    $scope.select = function(name, id, e){
      var elem = angular.element(e.srcElement);
      if (elem.hasClass('seleccionado')) {
        elem.removeClass('seleccionado');
        var index = $scope.idsIngredientesSeleccionados.indexOf(id);
        $scope.idsIngredientesSeleccionados.splice(index,1);
        repintarIngredientes();
      } else {
        var pop = document.getElementById('popupAddCantidad');        
        var posPopLeft = (window.innerWidth-236)/2;
        var posPopTop = (window.innerHeight-226)/2;
        angular.element(pop).css('left',posPopLeft + 'px');
        angular.element(pop).css('top',posPopTop + 'px');
        $scope.showPop = true;
        angular.element(listaIngredientes).addClass('conPop');  
        $scope.ingrediente = {'id':id, 'name':name, 'elem':elem};
      }
    }

    //add ingrediente a la lista de la receta despues de indicar cantidad
    $scope.addIngredienteToList = function(cantidad,tipo) {
      $scope.ingrediente.elem.addClass('seleccionado');   
      $scope.showPop=false;
      angular.element(listaIngredientes).removeClass('conPop');
      $scope.ingredientesSeleccionados.push({'id':$scope.ingrediente.id, 'name':$scope.ingrediente.name, 'tipo':tipo, 'cantidad':cantidad});
      $scope.cantidad = "";
      $scope.tipo = "unidades";
    }

    //cancelar pop cantidad
    $scope.cancelarAddIngredienteToList = function() {      
      $scope.showPop=false;
      angular.element(listaIngredientes).removeClass('conPop');
    }   

    //fill array idsRecetasSeleccionadas
    var fillIdsIngredientesSeleccionados = function(obj) {    	
        angular.forEach(obj, function(o) {
            $scope.idsIngredientesSeleccionados.push(o.id);            
        });
    }

    //list ingredientes pop
    var listAllIngredientes = function() {
	    var ingredientes = $scope.ingredientes = [];
	    persistencejs.fetchAllIngrediente($scope, function(){ 
	    	ingredientes = $scope.ingredientes;

	        // list recetas seleccionadas
	        angular.forEach(ingredientes, function(ingrediente) {            
	            if($scope.idsIngredientesSeleccionados.indexOf(ingrediente.id) !== -1) {
	                ingrediente.done=1;
	            } else {
	                ingrediente.done=0;
	            }
	        });
	    	$scope.refresh(); 
	    });     	
    }
    listAllIngredientes();

    //funcion para ordenar la lista de ingredientes del pop lista ingredientes. Por nombre y los ya agregados primero.
	$scope.sortFunction = function(ingrediente) {
	   var selecc = (ingrediente.done) ? 0 : 1;
	   return selecc + ingrediente.name;
	}	
}