
/* /\/\/\/\/\/\/\/\/\/\/\/\/\ SERVICES /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\ */

comprapp.factory('persistencejs', function(){

	persistence.store.websql.config(persistence, 'comprapp', 'comprapp database', 5*1024*1024);

	var Listas = persistence.define('listas', {
		name: 'TEXT',
    recetasJson: 'TEXT'    
	});

	var Recetas = persistence.define('recetas', {
		name: 'TEXT',
		description: 'TEXT',
    ingredientesJson: 'TEXT'  
	}); 

	var Ingredientes = persistence.define('ingredientes', {
		name: 'TEXT'    
	}); 


  persistence.schemaSync();
  return {
    //listas
    addLista: function(name, callback){
      var t = new Listas();
      t.name = name;
      persistence.add(t);
      persistence.flush(callback);          
      location.href='#/listas/' + t.id; 
    },
    getLista: function(scope, id, callback){
      var pieza = {};
      Listas.all().filter('id','=',id).one(function(item){     
        pieza.name = item.name;
        pieza.recetasJson = item.recetasJson;
        scope.pieza = pieza;
        callback();
      });       
    },
    editLista: function(id, newName, recetas){
      Listas.all().filter('id','=',id).one(function(item){
        if(item){
          item.name = newName;
          
          var recetasAux = [];
          for (var i = 0; i < recetas.length; i++) {
            recetasAux.push(recetas[i]);               
          };      
          item.recetasJson = JSON.stringify(recetasAux);

          persistence.flush();
        }
      });
    },
    removeLista: function(listas){
      Listas.all().filter('id','=',listas.id).destroyAll();
    },
    fetchAllLista: function( scope, callback ){            
      Listas.all().list(function(items){
        if( !items ) return [];
        var itemCount = items.length;
        var listas = [];
        items.forEach(function(item){
          listas.push({
            name: item.name,
            id: item.id
          });
          if(--itemCount == 0){
            scope.listas = listas;            
            callback();
          }
        });
      });
    },

    addReceta: function(name, description, ingr, callback){
      var t = new Recetas();
      t.name = name;
      t.description = description;  
      var ingrAux = [];
      for (var i = 0; i < ingr.length; i++) {
          ingrAux.push(ingr[i]);               
      };      
      t.ingredientesJson = JSON.stringify(ingrAux);
      persistence.add(t);
      persistence.flush(callback);     
    },    
    getReceta: function(scope, id, callback){
      var pieza = {};
      var recetaEliminada = false;
      Recetas.all().filter('id','=',id).one(function(item){
        if (item==null) {
          recetaEliminada = true;
        } else {
          pieza.name = item.name;        
          pieza.description = item.description;
          pieza.ingredientesJson = item.ingredientesJson;
        }
        scope.pieza = pieza;
        scope.recetaEliminada = recetaEliminada;
        callback();
      });       
    },
    editReceta: function(id, newName, newDescription, ingr){
      Recetas.all().filter('id','=',id).one(function(item){
        if(item){
            item.name = newName;
            item.description = newDescription;
            var ingrAux = [];
            for (var i = 0; i < ingr.length; i++) {
                ingrAux.push(ingr[i]);               
            };      
            item.ingredientesJson = JSON.stringify(ingrAux);
            persistence.flush();
        }
      });
    },
    removeReceta: function(recetas){
      Recetas.all().filter('id','=',recetas.id).destroyAll();
    },
    fetchAllReceta: function( scope, callback ){
      Recetas.all().list(function(items){
        if( !items ) return [];
        var itemCount = items.length;
        var recetas = [];
        items.forEach(function(item){
          recetas.push({
            name: item.name,
            description: item.description,
            id: item.id
          });
          if(--itemCount == 0){
            scope.recetas = recetas;
            callback();
          }
        });
      });
    },
    getRecetasEnLista: function(scope, listaId, recetas, callback) {
      Recetas.all().list(function(items){ 

        if( !items ) return [];
        var itemCount = items.length;
        var recetasEnLista = [];

        items.forEach(function(item){
          item.listas.list(null, function(itemLista) {
            if(itemLista[0]) {
              if (itemLista[0].id === listaId) {                
                recetasEnLista.push({
                  name: item.name,
                  description: item.description,
                  id: item.id
                });                
              }
            }

            if(--itemCount == 0){
              scope.recetasList = recetasEnLista;
              callback();
            }
          }); 
        });
      });
    },

    //ingredientes
    addIngrediente: function(name, callback){
      var t = new Ingredientes();
      t.name = name;
      persistence.add(t);
      persistence.flush(callback);     
    },
    getIngrediente: function(scope, id, callback){
      var pieza = {};
      Ingredientes.all().filter('id','=',id).one(function(item){     
        pieza.name = item.name;
        scope.pieza = pieza;
        callback();
      });       
    },
    editIngrediente: function(id, newName){
      Ingredientes.all().filter('id','=',id).one(function(item){
        if(item){
          item.name = newName;
          persistence.flush();
        }
      });
    },
    removeIngrediente: function(ingredientes){
      Ingredientes.all().filter('id','=',ingredientes.id).destroyAll();
    },
    fetchAllIngrediente: function( scope, callback ){
      Ingredientes.all().list(function(items){
        if( !items ) return [];
        var itemCount = items.length;
        var ingredientes = [];
        items.forEach(function(item){

          ingredientes.push({
            name: item.name,
            id: item.id
          });
          if(--itemCount == 0){
            scope.ingredientes = ingredientes;
            callback();
          }
        });
      });
    }    

  };
});